21/crm/routes/web.php
<?php

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', function () {
    return view('welcome');
});

Auth::routes();

Route::get('/home', 'HomeController@index')
    ->name('home')
    ->middleware('Sales');

Route::resource('/leads', 'LeadController')->middleware('Admin');

// Errors
Route::get('/403', function () {
    return view('errors.403');
})->name('403');

21/crm/app/Lead.php
<?php

namespace App;

use Illuminate\Database\Eloquent\Model;

class Lead extends Model
{
    //
}

21/crm/app/Http/Controllers/LeadController.php
<?php

namespace App\Http\Controllers;

use App\Http\Requests\LeadRequest;
use App\Lead;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\URL;
use Illuminate\Validation\Rule;
use Illuminate\Support\Facades\Validator;


class LeadController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return view
     */
    public function index()
    {
        return view('backoffice.leads.index', [
            'leads'=> Lead::where('status', 1)->get()
        ]);
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        return view('backoffice.leads.create');
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(LeadRequest $request)
    {
        $lead = new Lead();
        $lead->name = $request->input('name');
        $lead->phone = $request->input('phone');
        $lead->email = $request->input('email');
        $lead->address = $request->input('address');

        $lead->save();
        return redirect()->route('leads.show', $lead);
    }

    /**
     * Display the specified resource.
     *
     * @param  \App\Lead  $lead
     * @return \Illuminate\Http\Response
     */
    public function show(Lead $lead)
    {
        return view('backoffice.leads.show', ['lead'=> $lead]);
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  \App\Lead  $lead
     * @return \Illuminate\Http\Response
     */
    public function edit(Lead $lead)
    {
        return view('backoffice.leads.edit', ['lead'=> $lead]);
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  \App\Lead  $lead
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, Lead $lead)
    {

        $validator = Validator::make($request->all(), [
            'name'=> 'required|string',
            'phone'=> [
                'required',
                Rule::unique('leads')->ignore($lead)
            ],
            'email'=> [
                'email',
                Rule::unique('leads')->ignore($lead),
            ],
            'address'=> 'required',
        ]);

        if ($validator->fails()) {
            return back()
                ->withErrors($validator);
        }

        $lead->name = $request->input('name');
        $lead->phone = $request->input('phone');
        $lead->email = $request->input('email');
        $lead->address = $request->input('address');

        $lead->save();
        return redirect()->route('leads.show', $lead);
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  \App\Lead  $lead
     * @return \Illuminate\Http\Response
     */
    public function destroy(Lead $lead)
    {

        $lead->status = false;
        $lead->save();
        return back()->with('message', 'Deleted');;
    }
}

21/crm/resources/views/backoffice/leads/create.blade.php
@extends('layouts.app')

@section('title', 'Leads')

@section('pageHeader', 'Create Lead')

@section('content')
    <form action="{{ route('leads.store') }}" method="post">
        @csrf
        <div class="form-group">
            <label for="name">Name</label>
            <input type="text" class="form-control" name="name" id="name" value="{{ old('name') }}">
        </div>
        <div class="form-group">
            <label for="phone">Phone</label>
            <input type="tel" class="form-control" name="phone" id="phone" value="{{ old('phone') }}">
        </div>
        <div class="form-group">
            <label for="email">Email</label>
            <input type="email" class="form-control" name="email" id="email" value="{{ old('email') }}">
        </div>
        <div class="form-group">
            <label for="address">Address</label>
            <input type="text" class="form-control" name="address" id="address" value="{{ old('address') }}">
        </div>
        <div class="text-center">
            <button type="submit" class="btn btn-success">Save</button>
        </div>
    </form>
@endsection

21/crm/resources/views/backoffice/leads/edit.blade.php
@extends('layouts.app')

@section('title', 'Leads')

@section('pageHeader', 'Edit Lead')

@section('content')
    <form action="{{ route('leads.update', $lead) }}" method="post">
        @csrf
        @method('PUT')
        <div class="form-group">
            <label for="name">Name</label>
            <input type="text" class="form-control" name="name" id="name" value="{{ $lead->name }}">
        </div>
        <div class="form-group">
            <label for="phone">Phone</label>
            <input type="tel" class="form-control" name="phone" id="phone" value="{{ $lead->phone }}">
        </div>
        <div class="form-group">
            <label for="email">Email</label>
            <input type="email" class="form-control" name="email" id="email" value="{{ $lead->email }}">
        </div>
        <div class="form-group">
            <label for="address">Address</label>
            <input type="text" class="form-control" name="address" id="address" value="{{ $lead->address }}">
        </div>
        <div class="text-center">
            <button type="submit" class="btn btn-success">Save</button>
        </div>
    </form>
@endsection

21/crm/resources/views/backoffice/leads/index.blade.php
@extends('layouts.app')

@section('title', 'Leads')

@section('pageHeader', 'All Leads')

@section('content')
    <div class="text-right p-3">
        <a href="{{ route('leads.create') }}" class="btn btn-success">ADD NEW</a>
    </div>
    <table class="table table-bordered">
        <thead>
        <tr>
            <th>#</th>
            <th>Name</th>
            <th>Phone</th>
            <th>Email</th>
            <th>Actions</th>
        </tr>
        </thead>
        <tbody>
        @foreach($leads as $lead)
        <tr>
            <td>{{ $lead->id }}</td>
            <td>{{ $lead->name }}</td>
            <td>{{ $lead->phone }}</td>
            <td>{{ $lead->email }}</td>
            <td>
                <a href="{{ route('leads.show', $lead) }}" class="btn btn-info">Show</a>
                <a href="{{ route('leads.edit', $lead) }}" class="btn btn-primary">Edit</a>
                <form action="{{ route('leads.destroy', $lead) }}" method="post" style="display: inline-block">
                    @csrf
                    @method('DELETE')
                    <button type="submit" class="btn btn-danger">Delete</button>
                </form>
            </td>
        </tr>
        @endforeach
        </tbody>
    </table>
@endsection

21/crm/resources/views/backoffice/leads/show.blade.php
@extends('layouts.app')

@section('title', 'Leads')

@section('pageHeader', 'Show Lead')

@section('content')
    <h3><span class="text-bold">Name:</span> {{ $lead->name }}</h3>
    <p><span class="text-bold">Phone:</span> {{ $lead->phone }}</p>
    <p><span class="text-bold">Email:</span> {{ $lead->email }}</p>
    <p><span class="text-bold">Address:</span> {{ $lead->address }}</p>
    <div>
        <a href="{{ route('leads.edit', $lead) }}" class="btn btn-primary">Edit</a>
        <a href="{{ route('leads.destroy', $lead) }}" class="btn btn-danger">Delete</a>
    </div>

@endsection